Add unit tests for cfgupgrade with a real configuration
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/Curl \
68         src/Ganeti/DataCollectors \
69         src/Ganeti/HTools \
70         src/Ganeti/HTools/Backend \
71         src/Ganeti/HTools/Program \
72         src/Ganeti/Hypervisor \
73         src/Ganeti/Hypervisor/Xen \
74         src/Ganeti/Monitoring \
75         src/Ganeti/Query \
76         test/hs \
77         test/hs/Test \
78         test/hs/Test/Ganeti \
79         test/hs/Test/Ganeti/Block \
80         test/hs/Test/Ganeti/Block/Drbd \
81         test/hs/Test/Ganeti/Confd \
82         test/hs/Test/Ganeti/HTools \
83         test/hs/Test/Ganeti/HTools/Backend \
84         test/hs/Test/Ganeti/Hypervisor \
85         test/hs/Test/Ganeti/Hypervisor/Xen \
86         test/hs/Test/Ganeti/Query
87
88 # Haskell directories without the roots (src, test/hs)
89 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
90
91 DIRS = \
92         $(HS_DIRS) \
93         autotools \
94         daemons \
95         devel \
96         devel/data \
97         doc \
98         doc/css \
99         doc/examples \
100         doc/examples/gnt-debug \
101         doc/examples/hooks \
102         test/data/htools \
103         test/data/htools/rapi \
104         test/hs/shelltests \
105         lib \
106         lib/build \
107         lib/client \
108         lib/confd \
109         lib/http \
110         lib/hypervisor \
111         lib/impexpd \
112         lib/masterd \
113         lib/rapi \
114         lib/server \
115         lib/tools \
116         lib/utils \
117         lib/watcher \
118         man \
119         qa \
120         test \
121         test/data \
122         test/data/bdev-rbd \
123         test/data/ovfdata \
124         test/data/ovfdata/other \
125         test/py \
126         tools
127
128 ALL_APIDOC_HS_DIRS = \
129         $(APIDOC_HS_DIR) \
130         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
131
132 BUILDTIME_DIR_AUTOCREATE = \
133         scripts \
134         $(APIDOC_DIR) \
135         $(ALL_APIDOC_HS_DIRS) \
136         $(APIDOC_PY_DIR) \
137         $(COVERAGE_DIR) \
138         $(COVERAGE_HS_DIR) \
139         $(COVERAGE_PY_DIR) \
140         .hpc
141
142 BUILDTIME_DIRS = \
143         $(BUILDTIME_DIR_AUTOCREATE) \
144         doc/html \
145         doc/man-html
146
147 DIRCHECK_EXCLUDE = \
148         $(BUILDTIME_DIRS) \
149         ganeti-[0-9]*.[0-9]*.[0-9]* \
150         doc/html/_* \
151         doc/man-html/_* \
152         autom4te.cache
153
154 # some helper vars
155 COVERAGE_DIR = doc/coverage
156 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
157 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
158 APIDOC_DIR = doc/api
159 APIDOC_PY_DIR = $(APIDOC_DIR)/py
160 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
161
162 MAINTAINERCLEANFILES = \
163         $(maninput) \
164         doc/install-quick.rst \
165         doc/news.rst \
166         doc/upgrade.rst \
167         vcs-version
168
169 maintainer-clean-local:
170         rm -rf $(BUILDTIME_DIRS)
171
172 CLEANFILES = \
173         $(addsuffix /*.py[co],$(DIRS)) \
174         $(addsuffix /*.hi,$(HS_DIRS)) \
175         $(addsuffix /*.o,$(HS_DIRS)) \
176         $(PYTHON_BOOTSTRAP) \
177         epydoc.conf \
178         $(REPLACE_VARS_SED) \
179         $(SHELL_ENV_INIT) \
180         daemons/daemon-util \
181         daemons/ganeti-cleaner \
182         devel/squeeze-amd64.tar.gz \
183         devel/squeeze-amd64.conf \
184         $(mandocrst) \
185         doc/manpages-enabled.rst \
186         $(BUILT_EXAMPLES) \
187         doc/examples/bash_completion \
188         doc/examples/bash_completion-debug \
189         lib/_generated_rpc.py \
190         $(man_MANS) \
191         $(manhtml) \
192         tools/kvm-ifup \
193         tools/users-setup \
194         tools/vcluster-setup \
195         stamp-directories \
196         stamp-srclinks \
197         $(nodist_pkgpython_PYTHON) \
198         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
199         $(HS_BUILT_TEST_HELPERS) \
200         src/ganeti-confd \
201         src/ganeti-mond \
202         .hpc/*.mix src/*.tix test/hs/*.tix \
203         doc/hs-lint.html
204
205 GENERATED_FILES = \
206         $(built_base_sources) \
207         $(BUILT_PYTHON_SOURCES) \
208         $(PYTHON_BOOTSTRAP)
209
210 HS_GENERATED_FILES =
211 if WANT_HTOOLS
212 HS_GENERATED_FILES += $(HS_PROGS)
213 if ENABLE_CONFD
214 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
215 endif
216
217 if ENABLE_MOND
218 HS_GENERATED_FILES += src/ganeti-mond
219 endif
220 endif
221
222 built_base_sources = \
223         stamp-directories \
224         stamp-srclinks
225
226 built_python_base_sources = \
227         lib/_autoconf.py \
228         lib/_vcsversion.py
229
230 BUILT_PYTHON_SOURCES = \
231         $(built_python_base_sources) \
232         lib/_generated_rpc.py
233
234 # Generating the RPC wrappers depends on many things, so make sure
235 # it's built at the end of the built sources
236 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
237
238 # these are all built from the underlying %.in sources
239 BUILT_EXAMPLES = \
240         doc/examples/ganeti-kvm-poweroff.initd \
241         doc/examples/ganeti.cron \
242         doc/examples/ganeti.initd \
243         doc/examples/ganeti-master-role.ocf \
244         doc/examples/ganeti-node-role.ocf \
245         doc/examples/gnt-config-backup \
246         doc/examples/hooks/ipsec
247
248 nodist_pkgpython_PYTHON = \
249         $(BUILT_PYTHON_SOURCES)
250
251 noinst_PYTHON = \
252         lib/build/__init__.py \
253         lib/build/shell_example_lexer.py \
254         lib/build/sphinx_ext.py
255
256 pkgpython_PYTHON = \
257         lib/__init__.py \
258         lib/asyncnotifier.py \
259         lib/backend.py \
260         lib/bdev.py \
261         lib/bootstrap.py \
262         lib/cli.py \
263         lib/cmdlib.py \
264         lib/compat.py \
265         lib/config.py \
266         lib/constants.py \
267         lib/daemon.py \
268         lib/errors.py \
269         lib/ht.py \
270         lib/jqueue.py \
271         lib/jstore.py \
272         lib/locking.py \
273         lib/luxi.py \
274         lib/mcpu.py \
275         lib/netutils.py \
276         lib/objects.py \
277         lib/opcodes.py \
278         lib/outils.py \
279         lib/ovf.py \
280         lib/pathutils.py \
281         lib/qlang.py \
282         lib/query.py \
283         lib/rpc.py \
284         lib/rpc_defs.py \
285         lib/runtime.py \
286         lib/serializer.py \
287         lib/ssconf.py \
288         lib/ssh.py \
289         lib/storage.py \
290         lib/uidpool.py \
291         lib/vcluster.py \
292         lib/network.py \
293         lib/workerpool.py
294
295 client_PYTHON = \
296         lib/client/__init__.py \
297         lib/client/gnt_backup.py \
298         lib/client/gnt_cluster.py \
299         lib/client/gnt_debug.py \
300         lib/client/gnt_group.py \
301         lib/client/gnt_instance.py \
302         lib/client/gnt_job.py \
303         lib/client/gnt_node.py \
304         lib/client/gnt_network.py \
305         lib/client/gnt_os.py \
306         lib/client/gnt_storage.py
307
308 hypervisor_PYTHON = \
309         lib/hypervisor/__init__.py \
310         lib/hypervisor/hv_base.py \
311         lib/hypervisor/hv_chroot.py \
312         lib/hypervisor/hv_fake.py \
313         lib/hypervisor/hv_kvm.py \
314         lib/hypervisor/hv_lxc.py \
315         lib/hypervisor/hv_xen.py
316
317 rapi_PYTHON = \
318         lib/rapi/__init__.py \
319         lib/rapi/baserlib.py \
320         lib/rapi/client.py \
321         lib/rapi/client_utils.py \
322         lib/rapi/connector.py \
323         lib/rapi/rlib2.py \
324         lib/rapi/testutils.py
325
326 http_PYTHON = \
327         lib/http/__init__.py \
328         lib/http/auth.py \
329         lib/http/client.py \
330         lib/http/server.py
331
332 confd_PYTHON = \
333         lib/confd/__init__.py \
334         lib/confd/client.py
335
336 masterd_PYTHON = \
337         lib/masterd/__init__.py \
338         lib/masterd/iallocator.py \
339         lib/masterd/instance.py
340
341 impexpd_PYTHON = \
342         lib/impexpd/__init__.py
343
344 watcher_PYTHON = \
345         lib/watcher/__init__.py \
346         lib/watcher/nodemaint.py \
347         lib/watcher/state.py
348
349 server_PYTHON = \
350         lib/server/__init__.py \
351         lib/server/masterd.py \
352         lib/server/noded.py \
353         lib/server/rapi.py
354
355 pytools_PYTHON = \
356         lib/tools/__init__.py \
357         lib/tools/burnin.py \
358         lib/tools/ensure_dirs.py \
359         lib/tools/node_cleanup.py \
360         lib/tools/node_daemon_setup.py \
361         lib/tools/prepare_node_join.py
362
363 utils_PYTHON = \
364         lib/utils/__init__.py \
365         lib/utils/algo.py \
366         lib/utils/filelock.py \
367         lib/utils/hash.py \
368         lib/utils/io.py \
369         lib/utils/log.py \
370         lib/utils/lvm.py \
371         lib/utils/mlock.py \
372         lib/utils/nodesetup.py \
373         lib/utils/process.py \
374         lib/utils/retry.py \
375         lib/utils/text.py \
376         lib/utils/wrapper.py \
377         lib/utils/x509.py
378
379 docinput = \
380         doc/conf.py \
381         doc/css/style.css \
382         doc/admin.rst \
383         doc/cluster-merge.rst \
384         doc/design-2.0.rst \
385         doc/design-2.1.rst \
386         doc/design-2.2.rst \
387         doc/design-2.3.rst \
388         doc/design-2.4.rst \
389         doc/design-2.5.rst \
390         doc/design-2.6.rst \
391         doc/design-2.7.rst \
392         doc/design-autorepair.rst \
393         doc/design-bulk-create.rst \
394         doc/design-chained-jobs.rst \
395         doc/design-cpu-pinning.rst \
396         doc/design-device-uuid-name.rst \
397         doc/design-draft.rst \
398         doc/design-htools-2.3.rst \
399         doc/design-http-server.rst \
400         doc/design-impexp2.rst \
401         doc/design-lu-generated-jobs.rst \
402         doc/design-linuxha.rst \
403         doc/design-multi-reloc.rst \
404         doc/design-network.rst \
405         doc/design-node-add.rst \
406         doc/design-oob.rst \
407         doc/design-ovf-support.rst \
408         doc/design-opportunistic-locking.rst \
409         doc/design-partitioned.rst \
410         doc/design-query-splitting.rst \
411         doc/design-query2.rst \
412         doc/design-reason-trail.rst \
413         doc/design-resource-model.rst \
414         doc/design-restricted-commands.rst \
415         doc/design-shared-storage.rst \
416         doc/design-monitoring-agent.rst \
417         doc/design-virtual-clusters.rst \
418         doc/design-x509-ca.rst \
419         doc/design-hroller.rst \
420         doc/design-storagetypes.rst \
421         doc/devnotes.rst \
422         doc/glossary.rst \
423         doc/hooks.rst \
424         doc/iallocator.rst \
425         doc/index.rst \
426         doc/install-quick.rst \
427         doc/install.rst \
428         doc/locking.rst \
429         doc/manpages-disabled.rst \
430         doc/move-instance.rst \
431         doc/news.rst \
432         doc/ovfconverter.rst \
433         doc/rapi.rst \
434         doc/security.rst \
435         doc/upgrade.rst \
436         doc/virtual-cluster.rst \
437         doc/walkthrough.rst
438
439 # Generates file names such as "doc/man-gnt-instance.rst"
440 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
441
442 # Haskell programs to be installed in $PREFIX/bin
443 HS_BIN_PROGS=src/htools
444
445 # Haskell programs to be installed in the MYEXECLIB dir
446 HS_MYEXECLIB_PROGS=src/mon-collector
447
448 # Haskell programs to be compiled by "make really-all"
449 HS_COMPILE_PROGS= \
450         src/ganeti-mond \
451         src/hconfd \
452         src/rpc-test
453
454 # All Haskell non-test programs to be compiled but not automatically installed
455 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
456
457 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
458 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
459
460 HS_ALL_PROGS = \
461         $(HS_PROGS) \
462         test/hs/hpc-htools \
463         test/hs/hpc-mon-collector \
464         test/hs/htest \
465         $(HS_COMPILE_PROGS)
466
467 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
468 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
469
470 HFLAGS = \
471         -O -Wall -Werror -isrc \
472         -fwarn-monomorphism-restriction \
473         -fwarn-tabs \
474         $(GHC_BYVERSION_FLAGS)
475
476 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
477 HEXTRA =
478 # internal extra flags (used for test/hs/htest mainly)
479 HEXTRA_INT =
480 # exclude options for coverage reports
481 HPCEXCL = --exclude Main \
482         --exclude Ganeti.Constants \
483         --exclude Ganeti.HTools.QC \
484         --exclude Ganeti.THH \
485         --exclude Ganeti.Version \
486         --exclude Test.Ganeti.Attoparsec \
487         --exclude Test.Ganeti.TestCommon \
488         --exclude Test.Ganeti.TestHTools \
489         --exclude Test.Ganeti.TestHelper \
490         --exclude Test.Ganeti.TestImports \
491         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
492
493 HS_LIB_SRCS = \
494         src/Ganeti/Block/Drbd/Types.hs \
495         src/Ganeti/Block/Drbd/Parser.hs \
496         src/Ganeti/BasicTypes.hs \
497         src/Ganeti/Common.hs \
498         src/Ganeti/Compat.hs \
499         src/Ganeti/Confd/Client.hs \
500         src/Ganeti/Confd/Server.hs \
501         src/Ganeti/Confd/Types.hs \
502         src/Ganeti/Confd/Utils.hs \
503         src/Ganeti/Config.hs \
504         src/Ganeti/Curl/Multi.hs \
505         src/Ganeti/Daemon.hs \
506         src/Ganeti/DataCollectors/CLI.hs \
507         src/Ganeti/DataCollectors/Drbd.hs \
508         src/Ganeti/DataCollectors/Program.hs \
509         src/Ganeti/DataCollectors/Types.hs \
510         src/Ganeti/Errors.hs \
511         src/Ganeti/HTools/Backend/IAlloc.hs \
512         src/Ganeti/HTools/Backend/Luxi.hs \
513         src/Ganeti/HTools/Backend/Rapi.hs \
514         src/Ganeti/HTools/Backend/Simu.hs \
515         src/Ganeti/HTools/Backend/Text.hs \
516         src/Ganeti/HTools/CLI.hs \
517         src/Ganeti/HTools/Cluster.hs \
518         src/Ganeti/HTools/Container.hs \
519         src/Ganeti/HTools/ExtLoader.hs \
520         src/Ganeti/HTools/Graph.hs \
521         src/Ganeti/HTools/Group.hs \
522         src/Ganeti/HTools/Instance.hs \
523         src/Ganeti/HTools/Loader.hs \
524         src/Ganeti/HTools/Node.hs \
525         src/Ganeti/HTools/PeerMap.hs \
526         src/Ganeti/HTools/Program/Hail.hs \
527         src/Ganeti/HTools/Program/Harep.hs \
528         src/Ganeti/HTools/Program/Hbal.hs \
529         src/Ganeti/HTools/Program/Hcheck.hs \
530         src/Ganeti/HTools/Program/Hinfo.hs \
531         src/Ganeti/HTools/Program/Hscan.hs \
532         src/Ganeti/HTools/Program/Hspace.hs \
533         src/Ganeti/HTools/Program/Hroller.hs \
534         src/Ganeti/HTools/Program/Main.hs \
535         src/Ganeti/HTools/Types.hs \
536         src/Ganeti/Hypervisor/Xen/XmParser.hs \
537         src/Ganeti/Hypervisor/Xen/Types.hs \
538         src/Ganeti/Hash.hs \
539         src/Ganeti/JQueue.hs \
540         src/Ganeti/JSON.hs \
541         src/Ganeti/Jobs.hs \
542         src/Ganeti/Logging.hs \
543         src/Ganeti/Luxi.hs \
544         src/Ganeti/Monitoring/Server.hs \
545         src/Ganeti/Network.hs \
546         src/Ganeti/Objects.hs \
547         src/Ganeti/OpCodes.hs \
548         src/Ganeti/OpParams.hs \
549         src/Ganeti/Path.hs \
550         src/Ganeti/Query/Common.hs \
551         src/Ganeti/Query/Export.hs \
552         src/Ganeti/Query/Filter.hs \
553         src/Ganeti/Query/Group.hs \
554         src/Ganeti/Query/Job.hs \
555         src/Ganeti/Query/Language.hs \
556         src/Ganeti/Query/Network.hs \
557         src/Ganeti/Query/Node.hs \
558         src/Ganeti/Query/Query.hs \
559         src/Ganeti/Query/Server.hs \
560         src/Ganeti/Query/Types.hs \
561         src/Ganeti/Rpc.hs \
562         src/Ganeti/Runtime.hs \
563         src/Ganeti/Ssconf.hs \
564         src/Ganeti/THH.hs \
565         src/Ganeti/Types.hs \
566         src/Ganeti/Utils.hs
567
568 HS_TEST_SRCS = \
569         test/hs/Test/Ganeti/Attoparsec.hs \
570         test/hs/Test/Ganeti/BasicTypes.hs \
571         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
572         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
573         test/hs/Test/Ganeti/Common.hs \
574         test/hs/Test/Ganeti/Confd/Types.hs \
575         test/hs/Test/Ganeti/Confd/Utils.hs \
576         test/hs/Test/Ganeti/Daemon.hs \
577         test/hs/Test/Ganeti/Errors.hs \
578         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
579         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
580         test/hs/Test/Ganeti/HTools/CLI.hs \
581         test/hs/Test/Ganeti/HTools/Cluster.hs \
582         test/hs/Test/Ganeti/HTools/Container.hs \
583         test/hs/Test/Ganeti/HTools/Graph.hs \
584         test/hs/Test/Ganeti/HTools/Instance.hs \
585         test/hs/Test/Ganeti/HTools/Loader.hs \
586         test/hs/Test/Ganeti/HTools/Node.hs \
587         test/hs/Test/Ganeti/HTools/PeerMap.hs \
588         test/hs/Test/Ganeti/HTools/Types.hs \
589         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
590         test/hs/Test/Ganeti/JSON.hs \
591         test/hs/Test/Ganeti/Jobs.hs \
592         test/hs/Test/Ganeti/JQueue.hs \
593         test/hs/Test/Ganeti/Luxi.hs \
594         test/hs/Test/Ganeti/Network.hs \
595         test/hs/Test/Ganeti/Objects.hs \
596         test/hs/Test/Ganeti/OpCodes.hs \
597         test/hs/Test/Ganeti/Query/Filter.hs \
598         test/hs/Test/Ganeti/Query/Language.hs \
599         test/hs/Test/Ganeti/Query/Network.hs \
600         test/hs/Test/Ganeti/Query/Query.hs \
601         test/hs/Test/Ganeti/Rpc.hs \
602         test/hs/Test/Ganeti/Runtime.hs \
603         test/hs/Test/Ganeti/Ssconf.hs \
604         test/hs/Test/Ganeti/THH.hs \
605         test/hs/Test/Ganeti/TestCommon.hs \
606         test/hs/Test/Ganeti/TestHTools.hs \
607         test/hs/Test/Ganeti/TestHelper.hs \
608         test/hs/Test/Ganeti/Types.hs \
609         test/hs/Test/Ganeti/Utils.hs
610
611 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
612
613 HS_BUILT_SRCS = \
614         test/hs/Test/Ganeti/TestImports.hs \
615         src/Ganeti/Constants.hs \
616         src/Ganeti/Curl/Internal.hs \
617         src/Ganeti/Version.hs
618 HS_BUILT_SRCS_IN = \
619         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
620         src/Ganeti/Curl/Internal.hsc
621
622 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
623
624 $(RUN_IN_TEMPDIR): | stamp-directories
625
626 doc/html/index.html: ENABLE_MANPAGES =
627 doc/man-html/index.html: ENABLE_MANPAGES = 1
628 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
629
630 # Note: we use here an order-only prerequisite, as the contents of
631 # _autoconf.py are not actually influencing the html build output: it
632 # has to exist in order for the sphinx module to be loaded
633 # successfully, but we certainly don't want the docs to be rebuilt if
634 # it changes
635 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
636         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
637         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
638         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
639         | $(BUILT_PYTHON_SOURCES)
640         @test -n "$(SPHINX)" || \
641             { echo 'sphinx-build' not found during configure; exit 1; }
642 if !MANPAGES_IN_DOC
643         if test -n '$(ENABLE_MANPAGES)'; then \
644           echo 'Man pages in documentation were disabled at configure time' >&2; \
645           exit 1; \
646         fi
647 endif
648 ## Sphinx provides little control over what content should be included. Some
649 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
650 ## build two different versions of the documentation--once without man pages and
651 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
652 ## us with this, but requires running in a temporary directory. It moves the
653 ## correct files into place depending on environment variables.
654         dir=$(dir $@) && \
655         @mkdir_p@ $$dir && \
656         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
657         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
658             -d . \
659             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
660             -D release="$(PACKAGE_VERSION)" \
661             -D graphviz_dot="$(DOT)" \
662             -D enable_manpages="$(ENABLE_MANPAGES)" \
663             doc $(CURDIR)/$$dir && \
664         rm -f $$dir/.buildinfo $$dir/objects.inv
665         touch $@
666
667 doc/html: doc/html/index.html
668
669 doc/man-html: doc/man-html/index.html
670
671 doc/install-quick.rst: INSTALL
672 doc/news.rst: NEWS
673 doc/upgrade.rst: UPGRADE
674
675 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
676         set -e; \
677         { echo '.. This file is automatically updated at build time from $<.'; \
678           echo '.. Do not edit.'; \
679           echo; \
680           cat $<; \
681         } > $@
682
683 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
684         { echo '.. This file is automatically generated, do not edit!'; \
685           echo ''; \
686           echo 'Man pages'; \
687           echo '========='; \
688           echo; \
689           echo '.. toctree::'; \
690           echo '   :maxdepth: 1'; \
691           echo; \
692           for i in $(notdir $(mandocrst)); do \
693             echo "   $$i"; \
694           done | LC_ALL=C sort; \
695         } > $@
696
697 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
698 if MANPAGES_IN_DOC
699         { echo '.. This file is automatically updated at build time from $<.'; \
700           echo '.. Do not edit.'; \
701           echo; \
702           echo "$*"; \
703           echo '=========================================='; \
704           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
705         } > $@
706 else
707         echo 'Man pages in documentation were disabled at configure time' >&2; \
708         exit 1;
709 endif
710
711 # Things to build but not to install (add it to EXTRA_DIST if it should be
712 # distributed)
713 noinst_DATA = \
714         doc/html \
715         $(BUILT_EXAMPLES) \
716         doc/examples/bash_completion \
717         doc/examples/bash_completion-debug \
718         $(manhtml)
719
720 if MANPAGES_IN_DOC
721 noinst_DATA += doc/man-html
722 endif
723
724 gnt_scripts = \
725         scripts/gnt-backup \
726         scripts/gnt-cluster \
727         scripts/gnt-debug \
728         scripts/gnt-group \
729         scripts/gnt-instance \
730         scripts/gnt-job \
731         scripts/gnt-network \
732         scripts/gnt-node \
733         scripts/gnt-os \
734         scripts/gnt-storage
735
736 PYTHON_BOOTSTRAP_SBIN = \
737         daemons/ganeti-masterd \
738         daemons/ganeti-noded \
739         daemons/ganeti-rapi \
740         daemons/ganeti-watcher \
741         $(gnt_scripts)
742
743 PYTHON_BOOTSTRAP = \
744         $(PYTHON_BOOTSTRAP_SBIN) \
745         tools/burnin \
746         tools/ensure-dirs \
747         tools/node-cleanup \
748         tools/node-daemon-setup \
749         tools/prepare-node-join
750
751 qa_scripts = \
752         qa/__init__.py \
753         qa/ganeti-qa.py \
754         qa/qa_cluster.py \
755         qa/qa_config.py \
756         qa/qa_daemon.py \
757         qa/qa_env.py \
758         qa/qa_error.py \
759         qa/qa_group.py \
760         qa/qa_instance.py \
761         qa/qa_job.py \
762         qa/qa_node.py \
763         qa/qa_os.py \
764         qa/qa_rapi.py \
765         qa/qa_tags.py \
766         qa/qa_utils.py
767
768 bin_SCRIPTS =
769 if WANT_HTOOLS
770 bin_SCRIPTS += $(HS_BIN_PROGS)
771 install-exec-hook:
772         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
773 # FIXME: this is a hardcoded logic, instead of auto-resolving
774         $(LN_S) -f ../../../bin/htools \
775           $(DESTDIR)$(iallocatorsdir)/hail
776         for role in $(HS_BIN_ROLES); do \
777           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
778         done
779 endif
780
781 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
782         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
783           echo "Error: cannot run unittests without the development" \
784                " libraries (see devnotes.rst)" 1>&2; \
785           exit 1; \
786         fi
787         @rm -f $(notdir $@).tix
788         $(GHC) --make \
789           $(HFLAGS) \
790           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
791           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
792           $(HEXTRA) $(HEXTRA_INT) $@
793         @touch "$@"
794
795 # for the test/hs/htest binary, we need to enable profiling/coverage
796 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
797
798 # we compile the hpc-htools binary with the program coverage
799 test/hs/hpc-htools: HEXTRA_INT=-fhpc
800
801 # we compile the hpc-mon-collector binary with the program coverage
802 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
803
804 # test dependency
805 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
806
807 # rules for building profiling-enabled versions of the haskell
808 # programs: hs-prof does the full two-step build, whereas
809 # hs-prof-quick does only the final rebuild (hs-prof must have been
810 # run before)
811 .PHONY: hs-prof hs-prof-quick
812 hs-prof:
813         @if [ -z "$(TARGET)" ]; then \
814           echo "You need to define TARGET when running this rule" 1>&2; \
815           exit 1; \
816         fi
817         $(MAKE) $(AM_MAKEFLAGS) clean
818         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
819         rm -f $(HS_ALL_PROGS)
820         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
821
822 hs-prof-quick:
823         @if [ -z "$(TARGET)" ]; then \
824           echo "You need to define TARGET when running this rule" 1>&2; \
825           exit 1; \
826         fi
827         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
828
829 dist_sbin_SCRIPTS = \
830         tools/ganeti-listrunner
831
832 nodist_sbin_SCRIPTS = \
833         $(PYTHON_BOOTSTRAP_SBIN) \
834         daemons/ganeti-cleaner
835
836 if ENABLE_CONFD
837 src/ganeti-confd: src/hconfd
838         cp -f $< $@
839
840 nodist_sbin_SCRIPTS += src/ganeti-confd
841 endif
842
843 if ENABLE_MOND
844 nodist_sbin_SCRIPTS += src/ganeti-mond
845 endif
846
847 python_scripts = \
848         tools/cfgshell \
849         tools/cfgupgrade \
850         tools/cfgupgrade12 \
851         tools/cluster-merge \
852         tools/confd-client \
853         tools/fmtjson \
854         tools/lvmstrap \
855         tools/move-instance \
856         tools/ovfconverter \
857         tools/sanitize-config
858
859 dist_tools_SCRIPTS = \
860         $(python_scripts) \
861         tools/burnin \
862         tools/kvm-console-wrapper \
863         tools/master-ip-setup \
864         tools/xen-console-wrapper
865
866 nodist_tools_python_scripts = \
867         tools/node-cleanup
868
869 nodist_tools_SCRIPTS = \
870         $(nodist_tools_python_scripts) \
871         tools/users-setup \
872         tools/vcluster-setup
873
874 pkglib_python_scripts = \
875         daemons/import-export \
876         tools/check-cert-expired
877
878 nodist_pkglib_python_scripts = \
879         tools/ensure-dirs \
880         tools/node-daemon-setup \
881         tools/prepare-node-join
882
883 myexeclib_SCRIPTS = \
884         daemons/daemon-util \
885         tools/kvm-ifup \
886         $(pkglib_python_scripts) \
887         $(HS_MYEXECLIB_PROGS)
888
889 nodist_myexeclib_SCRIPTS = \
890         $(nodist_pkglib_python_scripts)
891
892 EXTRA_DIST = \
893         NEWS \
894         UPGRADE \
895         epydoc.conf.in \
896         pylintrc \
897         autotools/build-bash-completion \
898         autotools/build-rpc \
899         autotools/check-header \
900         autotools/check-imports \
901         autotools/check-man-dashes \
902         autotools/check-man-references \
903         autotools/check-man-warnings \
904         autotools/check-news \
905         autotools/check-python-code \
906         autotools/check-tar \
907         autotools/check-version \
908         autotools/convert-constants \
909         autotools/docpp \
910         autotools/gen-py-coverage \
911         autotools/sphinx-wrapper \
912         autotools/testrunner \
913         autotools/wrong-hardcoded-paths \
914         $(RUN_IN_TEMPDIR) \
915         daemons/daemon-util.in \
916         daemons/ganeti-cleaner.in \
917         $(pkglib_python_scripts) \
918         devel/upload \
919         devel/webserver \
920         tools/kvm-ifup.in \
921         tools/users-setup.in \
922         tools/vcluster-setup.in \
923         $(docinput) \
924         doc/html \
925         $(BUILT_EXAMPLES:%=%.in) \
926         doc/examples/ganeti.default \
927         doc/examples/ganeti.default-debug \
928         doc/examples/hooks/ethers \
929         doc/examples/gnt-debug/README \
930         doc/examples/gnt-debug/delay0.json \
931         doc/examples/gnt-debug/delay50.json \
932         test/py/lockperf.py \
933         test/py/testutils.py \
934         test/py/mocks.py \
935         $(dist_TESTS) \
936         $(TEST_FILES) \
937         man/footer.rst \
938         $(manrst) \
939         $(maninput) \
940         qa/qa-sample.json \
941         $(qa_scripts) \
942         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
943         $(HS_PROG_SRCS) \
944         src/lint-hints.hs \
945         test/hs/cli-tests-defs.sh \
946         test/hs/offline-test.sh \
947         .ghci
948
949 man_MANS = \
950         man/ganeti-cleaner.8 \
951         man/ganeti-confd.8 \
952         man/ganeti-listrunner.8 \
953         man/ganeti-masterd.8 \
954         man/ganeti-mond.8 \
955         man/ganeti-noded.8 \
956         man/ganeti-os-interface.7 \
957         man/ganeti-extstorage-interface.7 \
958         man/ganeti-rapi.8 \
959         man/ganeti-watcher.8 \
960         man/ganeti.7 \
961         man/gnt-backup.8 \
962         man/gnt-cluster.8 \
963         man/gnt-debug.8 \
964         man/gnt-group.8 \
965         man/gnt-network.8 \
966         man/gnt-instance.8 \
967         man/gnt-job.8 \
968         man/gnt-node.8 \
969         man/gnt-os.8 \
970         man/gnt-storage.8 \
971         man/hail.1 \
972         man/hbal.1 \
973         man/hcheck.1 \
974         man/hinfo.1 \
975         man/hscan.1 \
976         man/hspace.1 \
977         man/hroller.1 \
978         man/htools.1 \
979         man/mon-collector.7
980
981 # Remove extensions from all filenames in man_MANS
982 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
983
984 manrst = $(patsubst %,%.rst,$(mannoext))
985 manhtml = $(patsubst %.rst,%.html,$(manrst))
986 mangen = $(patsubst %.rst,%.gen,$(manrst))
987 maninput = \
988         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
989         $(patsubst %.html,%.html.in,$(manhtml)) \
990         $(mangen)
991
992 TEST_FILES = \
993         test/data/htools/clean-nonzero-score.data \
994         test/data/htools/common-suffix.data \
995         test/data/htools/empty-cluster.data \
996         test/data/htools/hail-alloc-drbd.json \
997         test/data/htools/hail-alloc-invalid-twodisks.json \
998         test/data/htools/hail-alloc-twodisks.json \
999         test/data/htools/hail-change-group.json \
1000         test/data/htools/hail-invalid-reloc.json \
1001         test/data/htools/hail-node-evac.json \
1002         test/data/htools/hail-reloc-drbd.json \
1003         test/data/htools/hbal-excl-tags.data \
1004         test/data/htools/hbal-split-insts.data \
1005         test/data/htools/invalid-node.data \
1006         test/data/htools/missing-resources.data \
1007         test/data/htools/multiple-master.data \
1008         test/data/htools/n1-failure.data \
1009         test/data/htools/rapi/groups.json \
1010         test/data/htools/rapi/info.json \
1011         test/data/htools/rapi/instances.json \
1012         test/data/htools/rapi/nodes.json \
1013         test/data/htools/unique-reboot-order.data \
1014         test/hs/shelltests/htools-balancing.test \
1015         test/hs/shelltests/htools-basic.test \
1016         test/hs/shelltests/htools-dynutil.test \
1017         test/hs/shelltests/htools-excl.test \
1018         test/hs/shelltests/htools-hail.test \
1019         test/hs/shelltests/htools-hroller.test \
1020         test/hs/shelltests/htools-hspace.test \
1021         test/hs/shelltests/htools-invalid.test \
1022         test/hs/shelltests/htools-multi-group.test \
1023         test/hs/shelltests/htools-no-backend.test \
1024         test/hs/shelltests/htools-rapi.test \
1025         test/hs/shelltests/htools-single-group.test \
1026         test/hs/shelltests/htools-text-backend.test \
1027         test/hs/shelltests/htools-mon-collector.test \
1028         test/data/bdev-drbd-8.0.txt \
1029         test/data/bdev-drbd-8.3.txt \
1030         test/data/bdev-drbd-disk.txt \
1031         test/data/bdev-drbd-net-ip4.txt \
1032         test/data/bdev-drbd-net-ip6.txt \
1033         test/data/bdev-rbd/json_output_empty.txt \
1034         test/data/bdev-rbd/json_output_extra_matches.txt \
1035         test/data/bdev-rbd/json_output_no_matches.txt \
1036         test/data/bdev-rbd/json_output_ok.txt \
1037         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1038         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1039         test/data/bdev-rbd/plain_output_new_ok.txt \
1040         test/data/bdev-rbd/plain_output_old_empty.txt \
1041         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1042         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1043         test/data/bdev-rbd/plain_output_old_ok.txt \
1044         test/data/bdev-rbd/output_invalid.txt \
1045         test/data/cert1.pem \
1046         test/data/cert2.pem \
1047         test/data/cluster_config_2.7.json \
1048         test/data/cluster_config_downgraded_2.7.json \
1049         test/data/instance-minor-pairing.txt \
1050         test/data/ip-addr-show-dummy0.txt \
1051         test/data/ip-addr-show-lo-ipv4.txt \
1052         test/data/ip-addr-show-lo-ipv6.txt \
1053         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1054         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1055         test/data/ip-addr-show-lo-oneline.txt \
1056         test/data/ip-addr-show-lo.txt \
1057         test/data/kvm_0.12.5_help.txt \
1058         test/data/kvm_0.15.90_help.txt \
1059         test/data/kvm_0.9.1_help.txt \
1060         test/data/kvm_0.9.1_help_boot_test.txt \
1061         test/data/kvm_1.0_help.txt \
1062         test/data/kvm_1.1.2_help.txt \
1063         test/data/ovfdata/compr_disk.vmdk.gz \
1064         test/data/ovfdata/config.ini \
1065         test/data/ovfdata/corrupted_resources.ovf \
1066         test/data/ovfdata/empty.ini \
1067         test/data/ovfdata/empty.ovf \
1068         test/data/ovfdata/ganeti.mf \
1069         test/data/ovfdata/ganeti.ovf \
1070         test/data/ovfdata/gzip_disk.ovf \
1071         test/data/ovfdata/new_disk.vmdk \
1072         test/data/ovfdata/no_disk.ini \
1073         test/data/ovfdata/no_disk_in_ref.ovf \
1074         test/data/ovfdata/no_os.ini \
1075         test/data/ovfdata/no_ovf.ova \
1076         test/data/ovfdata/other/rawdisk.raw \
1077         test/data/ovfdata/ova.ova \
1078         test/data/ovfdata/rawdisk.raw \
1079         test/data/ovfdata/second_disk.vmdk \
1080         test/data/ovfdata/unsafe_path.ini \
1081         test/data/ovfdata/virtualbox.ovf \
1082         test/data/ovfdata/wrong_config.ini \
1083         test/data/ovfdata/wrong_extension.ovd \
1084         test/data/ovfdata/wrong_manifest.mf \
1085         test/data/ovfdata/wrong_manifest.ovf \
1086         test/data/ovfdata/wrong_ova.ova \
1087         test/data/ovfdata/wrong_xml.ovf \
1088         test/data/proc_drbd8.txt \
1089         test/data/proc_drbd80-emptyline.txt \
1090         test/data/proc_drbd83.txt \
1091         test/data/proc_drbd83_sync.txt \
1092         test/data/proc_drbd83_sync_want.txt \
1093         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1094         test/data/qa-minimal-nodes-instances-only.json \
1095         test/data/sys_drbd_usermode_helper.txt \
1096         test/data/vgreduce-removemissing-2.02.02.txt \
1097         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1098         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1099         test/data/vgs-missing-pvs-2.02.02.txt \
1100         test/data/vgs-missing-pvs-2.02.66.txt \
1101         test/data/xen-xm-info-4.0.1.txt \
1102         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1103         test/data/xen-xm-list-4.0.1-four-instances.txt \
1104         test/data/xen-xm-list-long-4.0.1.txt \
1105         test/data/xen-xm-uptime-4.0.1.txt \
1106         test/py/ganeti-cli.test \
1107         test/py/gnt-cli.test \
1108         test/py/import-export_unittest-helper
1109
1110 python_tests = \
1111         doc/examples/rapi_testutils.py \
1112         test/py/cfgupgrade_unittest.py \
1113         test/py/docs_unittest.py \
1114         test/py/ganeti.asyncnotifier_unittest.py \
1115         test/py/ganeti.backend_unittest-runasroot.py \
1116         test/py/ganeti.backend_unittest.py \
1117         test/py/ganeti.bdev_unittest.py \
1118         test/py/ganeti.cli_unittest.py \
1119         test/py/ganeti.client.gnt_cluster_unittest.py \
1120         test/py/ganeti.client.gnt_instance_unittest.py \
1121         test/py/ganeti.client.gnt_job_unittest.py \
1122         test/py/ganeti.cmdlib_unittest.py \
1123         test/py/ganeti.compat_unittest.py \
1124         test/py/ganeti.confd.client_unittest.py \
1125         test/py/ganeti.config_unittest.py \
1126         test/py/ganeti.constants_unittest.py \
1127         test/py/ganeti.daemon_unittest.py \
1128         test/py/ganeti.errors_unittest.py \
1129         test/py/ganeti.hooks_unittest.py \
1130         test/py/ganeti.ht_unittest.py \
1131         test/py/ganeti.http_unittest.py \
1132         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1133         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1134         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1135         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1136         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1137         test/py/ganeti.hypervisor_unittest.py \
1138         test/py/ganeti.impexpd_unittest.py \
1139         test/py/ganeti.jqueue_unittest.py \
1140         test/py/ganeti.jstore_unittest.py \
1141         test/py/ganeti.locking_unittest.py \
1142         test/py/ganeti.luxi_unittest.py \
1143         test/py/ganeti.masterd.iallocator_unittest.py \
1144         test/py/ganeti.masterd.instance_unittest.py \
1145         test/py/ganeti.mcpu_unittest.py \
1146         test/py/ganeti.netutils_unittest.py \
1147         test/py/ganeti.objects_unittest.py \
1148         test/py/ganeti.opcodes_unittest.py \
1149         test/py/ganeti.outils_unittest.py \
1150         test/py/ganeti.ovf_unittest.py \
1151         test/py/ganeti.qlang_unittest.py \
1152         test/py/ganeti.query_unittest.py \
1153         test/py/ganeti.rapi.baserlib_unittest.py \
1154         test/py/ganeti.rapi.client_unittest.py \
1155         test/py/ganeti.rapi.resources_unittest.py \
1156         test/py/ganeti.rapi.rlib2_unittest.py \
1157         test/py/ganeti.rapi.testutils_unittest.py \
1158         test/py/ganeti.rpc_unittest.py \
1159         test/py/ganeti.runtime_unittest.py \
1160         test/py/ganeti.serializer_unittest.py \
1161         test/py/ganeti.server.rapi_unittest.py \
1162         test/py/ganeti.ssconf_unittest.py \
1163         test/py/ganeti.ssh_unittest.py \
1164         test/py/ganeti.storage_unittest.py \
1165         test/py/ganeti.tools.burnin_unittest.py \
1166         test/py/ganeti.tools.ensure_dirs_unittest.py \
1167         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1168         test/py/ganeti.tools.prepare_node_join_unittest.py \
1169         test/py/ganeti.uidpool_unittest.py \
1170         test/py/ganeti.utils.algo_unittest.py \
1171         test/py/ganeti.utils.filelock_unittest.py \
1172         test/py/ganeti.utils.hash_unittest.py \
1173         test/py/ganeti.utils.io_unittest-runasroot.py \
1174         test/py/ganeti.utils.io_unittest.py \
1175         test/py/ganeti.utils.log_unittest.py \
1176         test/py/ganeti.utils.lvm_unittest.py \
1177         test/py/ganeti.utils.mlock_unittest.py \
1178         test/py/ganeti.utils.nodesetup_unittest.py \
1179         test/py/ganeti.utils.process_unittest.py \
1180         test/py/ganeti.utils.retry_unittest.py \
1181         test/py/ganeti.utils.text_unittest.py \
1182         test/py/ganeti.utils.wrapper_unittest.py \
1183         test/py/ganeti.utils.x509_unittest.py \
1184         test/py/ganeti.utils_unittest.py \
1185         test/py/ganeti.vcluster_unittest.py \
1186         test/py/ganeti.workerpool_unittest.py \
1187         test/py/pycurl_reset_unittest.py \
1188         test/py/qa.qa_config_unittest.py \
1189         test/py/tempfile_fork_unittest.py
1190
1191 haskell_tests = test/hs/htest
1192
1193 dist_TESTS = \
1194         test/py/check-cert-expired_unittest.bash \
1195         test/py/daemon-util_unittest.bash \
1196         test/py/ganeti-cleaner_unittest.bash \
1197         test/py/import-export_unittest.bash \
1198         test/py/cli-test.bash \
1199         test/py/bash_completion.bash \
1200         $(python_tests)
1201
1202 nodist_TESTS =
1203 check_SCRIPTS =
1204
1205 if WANT_HSTESTS
1206 nodist_TESTS += $(haskell_tests)
1207 dist_TESTS += test/hs/offline-test.sh
1208 check_SCRIPTS += \
1209         test/hs/hpc-htools \
1210         test/hs/hpc-mon-collector \
1211         $(HS_BUILT_TEST_HELPERS)
1212 endif
1213
1214 TESTS = $(dist_TESTS) $(nodist_TESTS)
1215
1216 # Environment for all tests
1217 PLAIN_TESTS_ENVIRONMENT = \
1218         PYTHONPATH=. \
1219         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1220         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1221         $(RUN_IN_TEMPDIR)
1222
1223 # Environment for tests run by automake
1224 TESTS_ENVIRONMENT = \
1225         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1226
1227 all_python_code = \
1228         $(dist_sbin_SCRIPTS) \
1229         $(python_scripts) \
1230         $(pkglib_python_scripts) \
1231         $(nodist_pkglib_python_scripts) \
1232         $(nodist_tools_python_scripts) \
1233         $(python_tests) \
1234         $(pkgpython_PYTHON) \
1235         $(client_PYTHON) \
1236         $(hypervisor_PYTHON) \
1237         $(rapi_PYTHON) \
1238         $(server_PYTHON) \
1239         $(pytools_PYTHON) \
1240         $(http_PYTHON) \
1241         $(confd_PYTHON) \
1242         $(masterd_PYTHON) \
1243         $(impexpd_PYTHON) \
1244         $(utils_PYTHON) \
1245         $(watcher_PYTHON) \
1246         $(noinst_PYTHON) \
1247         $(qa_scripts)
1248
1249 srclink_files = \
1250         man/footer.rst \
1251         test/py/check-cert-expired_unittest.bash \
1252         test/py/daemon-util_unittest.bash \
1253         test/py/ganeti-cleaner_unittest.bash \
1254         test/py/import-export_unittest.bash \
1255         test/py/cli-test.bash \
1256         test/py/bash_completion.bash \
1257         test/hs/offline-test.sh \
1258         test/hs/cli-tests-defs.sh \
1259         $(all_python_code) \
1260         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1261         $(docinput)
1262
1263 check_python_code = \
1264         $(BUILD_BASH_COMPLETION) \
1265         $(CHECK_IMPORTS) \
1266         $(CHECK_HEADER) \
1267         $(DOCPP) \
1268         $(all_python_code)
1269
1270 lint_python_code = \
1271         ganeti \
1272         ganeti/http/server.py \
1273         $(dist_sbin_SCRIPTS) \
1274         $(python_scripts) \
1275         $(pkglib_python_scripts) \
1276         $(BUILD_BASH_COMPLETION) \
1277         $(CHECK_IMPORTS) \
1278         $(CHECK_HEADER) \
1279         $(DOCPP) \
1280         $(PYTHON_BOOTSTRAP)
1281
1282 standalone_python_modules = \
1283         lib/rapi/client.py \
1284         tools/ganeti-listrunner
1285
1286 pep8_python_code = \
1287         ganeti \
1288         ganeti/http/server.py \
1289         $(dist_sbin_SCRIPTS) \
1290         $(python_scripts) \
1291         $(pkglib_python_scripts) \
1292         $(BUILD_BASH_COMPLETION) \
1293         $(CHECK_HEADER) \
1294         $(DOCPP) \
1295         $(PYTHON_BOOTSTRAP) \
1296         qa
1297
1298 test/py/daemon-util_unittest.bash: daemons/daemon-util
1299
1300 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1301
1302 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1303
1304 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1305         sed -f $(REPLACE_VARS_SED) < $< > $@
1306         chmod +x $@
1307
1308 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1309         sed -f $(REPLACE_VARS_SED) < $< > $@
1310         chmod +x $@
1311
1312 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1313         sed -f $(REPLACE_VARS_SED) < $< > $@
1314         chmod +x $@
1315
1316 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1317         sed -f $(REPLACE_VARS_SED) < $< > $@
1318         chmod +x $@
1319
1320 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1321         sed -f $(REPLACE_VARS_SED) < $< > $@
1322
1323 doc/examples/bash_completion: BC_ARGS = --compact
1324 doc/examples/bash_completion-debug: BC_ARGS =
1325
1326 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1327         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1328         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1329         daemons/ganeti-cleaner \
1330         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1331         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1332           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1333
1334 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1335         lib/build/shell_example_lexer.py \
1336         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1337         @echo "Checking $< for hardcoded paths..."
1338         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1339           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1340           exit 1; \
1341         fi
1342         set -e ; \
1343         trap 'echo auto-removing $@; rm $@' EXIT; \
1344         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1345         $(CHECK_MAN_REFERENCES) $@; \
1346         trap - EXIT
1347
1348 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1349         @test -n "$(PANDOC)" || \
1350           { echo 'pandoc' not found during configure; exit 1; }
1351         set -o pipefail -e; \
1352         trap 'echo auto-removing $@; rm $@' EXIT; \
1353         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1354           sed -e 's/\\@/@/g' > $@; \
1355         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1356         $(CHECK_MAN_DASHES) $@; \
1357         trap - EXIT
1358
1359 man/%.html.in: man/%.gen man/footer.rst
1360         @test -n "$(PANDOC)" || \
1361           { echo 'pandoc' not found during configure; exit 1; }
1362         set -o pipefail ; \
1363         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1364           sed -e 's/\\@/@/g' > $@
1365
1366 man/%: man/%.in  $(REPLACE_VARS_SED)
1367         sed -f $(REPLACE_VARS_SED) < $< > $@
1368
1369 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1370         sed -f $(REPLACE_VARS_SED) < $< > $@
1371
1372 vcs-version:
1373         if test -d .git; then \
1374           git describe > $@; \
1375         elif test ! -f $@ ; then \
1376           echo "Cannot auto-generate $@ file"; exit 1; \
1377         fi
1378
1379 .PHONY: clean-vcs-version
1380 clean-vcs-version:
1381         rm -f vcs-version
1382
1383 .PHONY: regen-vcs-version
1384 regen-vcs-version:
1385         @set -e; \
1386         cd $(srcdir); \
1387         if test -d .git; then \
1388           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1389           git describe > $$T; \
1390           if ! cmp --quiet $$T vcs-version; then \
1391             mv $$T vcs-version; \
1392           fi; \
1393         fi
1394
1395 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1396         vcs-version $(built_base_sources)
1397         set -e; \
1398         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1399         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1400
1401 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1402         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1403         lib/jstore.py $(RUN_IN_TEMPDIR) \
1404         $(CONVERT_CONSTANTS) $(built_base_sources) \
1405         | lib/_vcsversion.py
1406         set -e; \
1407         { cat $< ; \
1408           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1409         } > $@
1410
1411 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1412         hsc2hs -o $@ $<
1413
1414 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1415         $(built_base_sources)
1416         set -e; \
1417         { cat $< ; \
1418           echo ; \
1419           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1420             echo "import $$name ()" ; \
1421           done ; \
1422         } > $@
1423
1424 lib/_autoconf.py: Makefile | stamp-directories
1425         set -e; \
1426         { echo '# This file is automatically generated, do not edit!'; \
1427           echo '#'; \
1428           echo ''; \
1429           echo '"""Build-time configuration for Ganeti.'; \
1430           echo '';\
1431           echo 'This file is autogenerated by the build process.'; \
1432           echo 'For any changes you need to re-run ./configure (and'; \
1433           echo 'not edit by hand).'; \
1434           echo ''; \
1435           echo '"""'; \
1436           echo ''; \
1437           echo '# pylint: disable=C0301,C0324'; \
1438           echo '# because this is autogenerated, we do not want'; \
1439           echo '# style warnings' ; \
1440           echo ''; \
1441           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1442           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1443           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1444           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1445           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1446           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1447           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1448           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1449           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1450           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1451           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1452           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1453           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1454           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1455           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1456           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1457           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1458           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1459           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1460           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1461           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1462           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1463           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1464           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1465           echo "KVM_PATH = '$(KVM_PATH)'"; \
1466           echo "IP_PATH = '$(IP_PATH)'"; \
1467           echo "SOCAT_PATH = '$(SOCAT)'"; \
1468           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1469           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1470           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1471           echo "TOOLSDIR = '$(toolsdir)'"; \
1472           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1473           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1474           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1475           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1476           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1477           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1478           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1479           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1480           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1481           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1482           echo "RAPI_USER = '$(RAPI_USER)'"; \
1483           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1484           echo "CONFD_USER = '$(CONFD_USER)'"; \
1485           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1486           echo "NODED_USER = '$(NODED_USER)'"; \
1487           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1488           echo "MOND_USER = '$(MOND_USER)'"; \
1489           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1490           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1491           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1492           echo "HTOOLS = True"; \
1493           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1494           echo "XEN_CMD = '$(XEN_CMD)'"; \
1495           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1496           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1497           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1498 ## Write dictionary with man page name as the key and the section number as the
1499 ## value
1500           echo "MAN_PAGES = {"; \
1501           for i in $(notdir $(man_MANS)); do \
1502             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1503           done; \
1504           echo "}"; \
1505         } > $@
1506
1507 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1508         set -e; \
1509         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1510         { echo '# This file is automatically generated, do not edit!'; \
1511           echo '#'; \
1512           echo ''; \
1513           echo '"""Build-time VCS version number for Ganeti.'; \
1514           echo '';\
1515           echo 'This file is autogenerated by the build process.'; \
1516           echo 'For any changes you need to re-run ./configure (and'; \
1517           echo 'not edit by hand).'; \
1518           echo ''; \
1519           echo '"""'; \
1520           echo ''; \
1521           echo '# pylint: disable=C0301,C0324'; \
1522           echo '# because this is autogenerated, we do not want'; \
1523           echo '# style warnings' ; \
1524           echo ''; \
1525           echo "VCS_VERSION = '$$VCSVER'"; \
1526         } > $@
1527
1528 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1529         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1530
1531 $(SHELL_ENV_INIT): Makefile stamp-directories
1532         set -e; \
1533         { echo '# Allow overriding for tests'; \
1534           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1535           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1536           echo; \
1537           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1538           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1539           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1540           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1541           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1542         } > $@
1543
1544 ## Writes sed script to replace placeholders with build-time values. The
1545 ## additional quotes after the first @ sign are necessary to stop configure
1546 ## from replacing those values as well.
1547 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1548         set -e; \
1549         { echo 's#@''PREFIX@#$(prefix)#g'; \
1550           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1551           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1552           echo 's#@''BINDIR@#$(bindir)#g'; \
1553           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1554           echo 's#@''LIBDIR@#$(libdir)#g'; \
1555           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1556           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1557           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1558           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1559           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1560           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1561           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1562           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1563           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1564           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1565           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1566           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1567           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1568           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1569           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1570           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1571           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1572           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1573           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1574           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1575           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1576           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1577           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1578           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1579           echo; \
1580           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1581           echo '  r $(SHELL_ENV_INIT)'; \
1582           echo '  d'; \
1583           echo '}'; \
1584         } > $@
1585
1586 # Using deferred evaluation
1587 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1588 daemons/ganeti-watcher: MODULE = ganeti.watcher
1589 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1590 tools/burnin: MODULE = ganeti.tools.burnin
1591 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1592 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1593 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1594 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1595 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1596
1597 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1598         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1599         set -e; \
1600         { echo '#!/usr/bin/python'; \
1601           echo '# This file is automatically generated, do not edit!'; \
1602           echo "# Edit $(MODULE) instead."; \
1603           echo; \
1604           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1605           echo; \
1606           echo '# pylint: disable=C0103'; \
1607           echo '# C0103: Invalid name'; \
1608           echo; \
1609           echo 'import sys'; \
1610           echo 'import $(MODULE) as main'; \
1611           echo; \
1612           echo '# Temporarily alias commands until bash completion'; \
1613           echo '# generator is changed'; \
1614           echo 'if hasattr(main, "commands"):'; \
1615           echo '  commands = main.commands # pylint: disable=E1101'; \
1616           echo 'if hasattr(main, "aliases"):'; \
1617           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1618           echo; \
1619           echo 'if __name__ == "__main__":'; \
1620           echo '  sys.exit(main.Main())'; \
1621         } > $@
1622         chmod u+x $@
1623
1624 $(HS_BUILT_TEST_HELPERS): Makefile
1625         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1626         set -e; \
1627         { echo '#!/bin/sh'; \
1628           echo '# This file is automatically generated, do not edit!'; \
1629           echo "# Edit Makefile.am instead."; \
1630           echo; \
1631           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1632         } > $@
1633         chmod u+x $@
1634
1635 stamp-directories: Makefile
1636         $(MAKE) $(AM_MAKEFLAGS) ganeti
1637         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1638         touch $@
1639
1640 # We need to create symlinks because "make distcheck" will not install Python
1641 # files when building.
1642 stamp-srclinks: Makefile | stamp-directories
1643         set -e; \
1644         for i in $(srclink_files); do \
1645           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1646             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1647           fi; \
1648         done
1649         touch $@
1650
1651 .PHONY: ganeti
1652 ganeti:
1653         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1654
1655 .PHONY: check-dirs
1656 check-dirs: $(GENERATED_FILES)
1657         @set -e; \
1658         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1659           error=; \
1660           while read dir; do \
1661             case "$$dir" in \
1662               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1663               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1664             esac; \
1665           done; \
1666           for dir in $(DIRS); do \
1667             if ! test -d "$$dir"; then \
1668               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1669               error=1; \
1670             fi \
1671           done; \
1672           test -z "$$error"; \
1673         }
1674
1675 .PHONY: check-local
1676 check-local: check-dirs $(GENERATED_FILES)
1677         $(CHECK_PYTHON_CODE) $(check_python_code)
1678         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1679         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1680         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1681         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1682         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1683         error= ; \
1684         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1685           echo "Incorrect version in README, expected $$expver" >&2; \
1686           error=1; \
1687         fi; \
1688         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1689             doc/security.rst; do \
1690           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1691             "Documents Ganeti version $$expver"; then \
1692             echo "Incorrect version in $$file, expected $$expver" >&2; \
1693             error=1; \
1694           fi; \
1695         done; \
1696         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1697           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1698           error=1; \
1699         fi; \
1700         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1701           ".. Last updated for Ganeti $$expver"; then \
1702           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1703           error=1; \
1704         fi; \
1705         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1706           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1707             echo "Longest line in $$file is longer than 80 characters" >&2; \
1708             error=1; \
1709           fi; \
1710         done; \
1711         test -z "$$error"
1712
1713 .PHONY: hs-tests
1714 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1715         @rm -f htest.tix
1716         ./test/hs/htest
1717
1718 .PHONY: hs-shell
1719 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1720         @rm -f hpc-htools.tix hpc-mon-collector.tix
1721         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1722
1723 .PHONY: hs-check
1724 hs-check: hs-tests hs-shell
1725
1726 # E111: indentation is not a multiple of four
1727 # E121: continuation line indentation is not a multiple of four
1728 #       (since our indent level is not 4)
1729 # E125: continuation line does not distinguish itself from next logical line
1730 #       (since our indent level is not 4)
1731 # E127: continuation line over-indented for visual indent
1732 #       (since our indent level is not 4)
1733 # note: do NOT add E128 here; it's a valid style error in most cases!
1734 # I've seen real errors, but also some cases were we indent wrongly
1735 # due to line length; try to rework the cases where it is triggered,
1736 # instead of silencing it
1737 # E261: at least two spaces before inline comment
1738 # E501: line too long (80 characters)
1739 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1740
1741 # For excluding pep8 expects filenames only, not whole paths
1742 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1743
1744 LINT_TARGETS = pylint pylint-qa
1745 if HAS_PEP8
1746 LINT_TARGETS += pep8
1747 endif
1748 if HAS_HLINT
1749 LINT_TARGETS += hlint
1750 endif
1751
1752 .PHONY: lint
1753 lint: $(LINT_TARGETS)
1754
1755 .PHONY: pylint
1756 pylint: $(GENERATED_FILES)
1757         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1758         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1759
1760 .PHONY: pylint-qa
1761 pylint-qa: $(GENERATED_FILES)
1762         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1763         cd $(top_srcdir)/qa && \
1764           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1765           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1766
1767 .PHONY: pep8
1768 pep8: $(GENERATED_FILES)
1769         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1770         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1771           --repeat $(pep8_python_code)
1772
1773 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1774 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1775 .PHONY: hlint
1776 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1777         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1778         @rm -f doc/hs-lint.html
1779         if tty -s; then C="-c"; else C=""; fi; \
1780         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1781           --ignore "Use first" \
1782           --ignore "Use &&&" \
1783           --ignore "Use void" \
1784           --ignore "Reduce duplication" \
1785           --hint src/lint-hints \
1786           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1787         @if [ ! -f doc/hs-lint.html ]; then \
1788           echo "All good" > doc/hs-lint.html; \
1789         fi
1790
1791 # a dist hook rule for updating the vcs-version file; this is
1792 # hardcoded due to where it needs to build the file...
1793 dist-hook:
1794         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1795         rm -f $(top_distdir)/vcs-version
1796         cp -p $(srcdir)/vcs-version $(top_distdir)
1797
1798 # a distcheck hook rule for catching revision control directories
1799 distcheck-hook:
1800         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1801           echo "Found revision control files in final archive." 1>&2; \
1802           exit 1; \
1803         fi
1804         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1805           echo "Found Python byte code in final archive." 1>&2; \
1806           exit 1; \
1807         fi
1808         if find $(top_distdir) -name '*~' | grep .; then \
1809           echo "Found backup files in final archive." 1>&2; \
1810           exit 1; \
1811         fi
1812 # Empty files or directories should not be distributed. They can cause
1813 # unnecessary warnings for packagers. Directories used by automake during
1814 # distcheck must be excluded.
1815         if find $(top_distdir) -empty -and -not \( \
1816             -path $(top_distdir)/_build -or \
1817             -path $(top_distdir)/_inst \) | grep .; then \
1818           echo "Found empty files or directories in final archive." 1>&2; \
1819           exit 1; \
1820         fi
1821         if test -n "$(BUILD_RELEASE)" && \
1822            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1823            echo "Found unreleased version in NEWS." >&2; \
1824            exit 1; \
1825         fi
1826         if test -e $(top_distdir)/doc/man-html; then \
1827           echo "Found documentation including man pages in final archive" >&2; \
1828           exit 1; \
1829         fi
1830
1831 # When building a release, stricter checks should be used
1832 distcheck-release dist-release: export BUILD_RELEASE = 1
1833 distcheck-release: distcheck
1834
1835 distrebuildcheck: dist
1836         set -e; \
1837         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1838         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1839         cd $$builddir; \
1840         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1841         cd $(distdir); \
1842         ./configure; \
1843         $(MAKE) maintainer-clean; \
1844         cp $(abs_srcdir)/vcs-version .; \
1845         ./configure; \
1846         $(MAKE) $(AM_MAKEFLAGS)
1847
1848 dist-release: dist
1849         set -e; \
1850         for i in $(DIST_ARCHIVES); do \
1851           echo -n "Checking $$i ... "; \
1852           autotools/check-tar < $$i; \
1853           echo OK; \
1854         done
1855
1856 install-exec-local:
1857         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1858           "$(DESTDIR)${localstatedir}/log/ganeti" \
1859           "$(DESTDIR)${localstatedir}/run/ganeti"
1860
1861 .PHONY: apidoc
1862 if WANT_HSAPIDOC
1863 apidoc: py-apidoc hs-apidoc
1864 else
1865 apidoc: py-apidoc
1866 endif
1867
1868 .PHONY: py-apidoc
1869 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1870         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1871         $(RUN_IN_TEMPDIR) epydoc -v \
1872           --conf $(CURDIR)/epydoc.conf \
1873           --output $(CURDIR)/$(APIDOC_PY_DIR)
1874
1875 .PHONY: hs-apidoc
1876 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1877
1878 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1879         @test -n "$(HSCOLOUR)" || \
1880             { echo 'HsColour' not found during configure; exit 1; }
1881         @test -n "$(HADDOCK)" || \
1882             { echo 'haddock' not found during configure; exit 1; }
1883         rm -rf $(APIDOC_HS_DIR)/*
1884         for i in $(ALL_APIDOC_HS_DIRS); do \
1885           @mkdir_p@ $$i; \
1886           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1887         done
1888         set -e ; \
1889         export LC_ALL=en_US.UTF-8; \
1890         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1891         if [ "$(HS_PARALLEL3)" ]; \
1892         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1893         fi; \
1894         if [ "$(HS_REGEX_PCRE)" ]; \
1895         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1896         fi; \
1897         for file in $(HS_LIBTESTBUILT_SRCS); do \
1898           f_nosrc=$${file##src/}; \
1899           f_notst=$${f_nosrc##test/hs/}; \
1900           f_html=$${f_notst%%.hs}.html; \
1901           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1902         done ; \
1903         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1904           -t ganeti -p src/haddock-prologue \
1905           --source-module="%{MODULE/.//}.html" \
1906           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1907           $$OPTGHC \
1908           $(HS_LIBTESTBUILT_SRCS)
1909
1910 .PHONY: TAGS
1911 TAGS: $(GENERATED_FILES)
1912         rm -f TAGS
1913         $(GHC) -e ":etags" -v0 \
1914           $(filter-out -O -Werror,$(HFLAGS)) \
1915           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1916           $(HS_LIBTEST_SRCS)
1917         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1918           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1919           -path './qa/*.py' | \
1920           etags -l python -a -
1921
1922 .PHONY: coverage
1923 if WANT_HTOOLS
1924 coverage: py-coverage hs-coverage
1925 else
1926 coverage: py-coverage
1927 endif
1928
1929 .PHONY: py-coverage
1930 py-coverage: $(GENERATED_FILES) $(python_tests)
1931         @test -n "$(PYCOVERAGE)" || \
1932             { echo 'python-coverage' not found during configure; exit 1; }
1933         set -e; \
1934         COVERAGE=$(PYCOVERAGE) \
1935         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1936         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1937         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1938         $(PLAIN_TESTS_ENVIRONMENT) \
1939         $(abs_top_srcdir)/autotools/gen-py-coverage \
1940         $(python_tests)
1941
1942 .PHONY: hs-coverage
1943 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1944         rm -f *.tix
1945         $(MAKE) $(AM_MAKEFLAGS) hs-check
1946         @mkdir_p@ $(COVERAGE_HS_DIR)
1947         hpc sum --union $(HPCEXCL) \
1948           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1949         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1950         hpc report coverage-hs.tix
1951         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1952
1953 # Special "kind-of-QA" target for htools, needs special setup (all
1954 # tools compiled with -fhpc)
1955 .PHONY: live-test
1956 live-test: all
1957         set -e ; \
1958         cd src; \
1959         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1960         rm -f *.tix *.mix; \
1961         ./live-test.sh; \
1962         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1963           --output=live-test.tix ; \
1964         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1965         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1966           --srcdir=.. $(HPCEXCL) ; \
1967         hpc report --srcdir=.. live-test $(HPCEXCL)
1968
1969 commit-check: distcheck lint apidoc
1970
1971 .PHONY: gitignore-check
1972 gitignore-check:
1973         @if [ -n "`git status --short`" ]; then \
1974           echo "Git status is not clean!" 1>&2 ; \
1975           git status --short; \
1976           exit 1; \
1977         fi
1978
1979 # target to rebuild all man pages (both groff and html output)
1980 .PHONY: man
1981 man: $(man_MANS) $(manhtml)
1982
1983 # Target that builds all binaries (including those that are not
1984 # rebuilt except when running the tests)
1985 .PHONY: really-all
1986 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1987
1988 # we don't need the ancient implicit rules:
1989 %: %,v
1990 %: RCS/%,v
1991 %: RCS/%
1992 %: s.%
1993 %: SCCS/s.%
1994
1995 -include ./Makefile.local
1996
1997 # vim: set noet :